package ex

import (
	"testing"
	"time"
)

func TestInlineFuncs(t *testing.T) {
	f := func() bool {
		return true
	}
	if !f() {
		t.Fail()
	}
}

func TestGoRoutines(t *testing.T) {
	var ok bool
	f := func() {
		// doing something
		ok = true
	}
	go f()
	// show without sleep
	time.Sleep(10000 * time.Nanosecond)
	if !ok {
		t.Fail()
	}
}

func TestChannels(t *testing.T) {
	c := make(chan int)
	doStuff := func(k int) {
		c <- k
	}
	// cannot guarantee order, they are concurrent
	for i := 0; i < 10; i++ {
		go doStuff(i)
	}
	// read all values, order is random
	for i := 0; i < 10; i++ {
		got := <-c
		t.Log(got)
	}
	//t.Fail()
}
