package ex

import (
	"io"

	"golang.org/x/net/html"
)

func ReplaceLinks(w io.Writer, r io.Reader) (err error) {
	doc, err := html.Parse(r)
	if err != nil {
		return
	}
	replaceLinksWithSpan(doc)
	return html.Render(w, doc)
}

func replaceLinksWithSpan(n *html.Node) {
	for c := n.FirstChild; c != nil; c = c.NextSibling {
		if c.Type == html.ElementNode && c.Data == "a" {
			c.Data = "span"
			removeAttribute(c, "href")
		} else {
			replaceLinksWithSpan(c)
		}
	}
}

func removeAttribute(c *html.Node, key string) {
	for i, a := range c.Attr {
		if a.Key == key {
			c.Attr = append(c.Attr[:i], c.Attr[i+1:]...)
			break
		}
	}
}
