package ex

import (
	"io/ioutil"
	"testing"
	"time"
)

// TestTimingIssue shows that times are really hard to trust.
func xTestTimingIssue(t *testing.T) {
	before := time.Now()
	// Create a file
	fh, _ := ioutil.TempFile("", "afile")
	fi, _ := fh.Stat()
	fh.Close()
	mod := fi.ModTime()
	if before.After(mod) {
		t.Logf("before = %v\n", before)
		t.Logf("mod    = %v\n", mod)
		t.Error("How can this be?")
	}
}
